unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls
  , TypInfo
  , fpjson
  , MyClasses
  ;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Memo1: TMemo;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    procedure WriteToMemo(AMyObject: TMyObject);
  public

  end;

var
  Form1: TForm1;

implementation

uses
  fpjsonrtti
  , Contnrs
  ;

{$R *.lfm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
var
  MyObject1: TMyObject;
  MyObject1_1: TMyObject;
  MyObject1_2: TMyObject;
  MyObject1_1_1: TMyObject;
  jsoSerialize: TJSONStreamer;
  ts: TStringStream;
  s: String;
begin
  MyObject1 := TMyObject.Create;
  MyObject1_1 := TMyObject.Create;
  MyObject1_2 := TMyObject.Create;
  MyObject1_1_1 := TMyObject.Create;
  jsoSerialize := TJSONStreamer.Create(nil);
  try
    MyObject1.Name := 'Max';
    MyObject1.TestProp1 := 'Ebene 1';
    MyObject1.TestProp2 := 1;

    MyObject1_1.Name := 'Moritz';
    MyObject1_1.TestProp1 := 'Ebene 1_1';
    MyObject1_1.TestProp2 := 11;
    MyObject1.Items.Add(MyObject1_1);

    MyObject1_2.Name := 'Hans';
    MyObject1_2.TestProp1 := 'Ebene 1_2';
    MyObject1_2.TestProp2 := 12;
    MyObject1.Items.Add(MyObject1_2);

    MyObject1_1_1.Name := 'Peter';
    MyObject1_1_1.TestProp1 := 'Ebene 1_1_1';
    MyObject1_1_1.TestProp2 := 111;
    MyObject1_1.Items.Add(MyObject1_1_1);

    s := jsoSerialize.ObjectToJSONString(MyObject1);
    ts := TStringStream.Create(s);
    try
      ts.SaveToFile('Test.json');
    finally
      ts.Free;
    end;

    Memo1.Lines.Text := s;
  finally
    jsoSerialize.Free;
    MyObject1.Free;
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  MyObject: TMyObject;
  jsoDeSerialize: TJSONDeStreamer;
  ts: TStringStream;
  s: String;
  i: Integer;
begin
  ts := TStringStream.Create;
  MyObject := TMyObject.Create;
  jsoDeSerialize := TJSONDeStreamer.Create(nil);
  try
    ts.LoadFromFile('Test.json');

    s := ts.DataString;
    jsoDeSerialize.JSONToObject(s, MyObject);

    WriteToMemo(MyObject);
  finally
    jsoDeSerialize.Free;
    MyObject.Free;
    ts.Free;
  end;

end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Memo1.Clear;
end;

procedure TForm1.WriteToMemo(AMyObject: TMyObject);
var
  i: Integer;
begin
  Memo1.Lines.Add(AMyObject.Name);
  Memo1.Lines.Add(AMyObject.TestProp1);
  Memo1.Lines.Add(IntToStr(AMyObject.TestProp2));

  for i:=0 to AMyObject.Items.Count-1 do
  begin
    Memo1.Lines.Add('----------Sub von '+AMyObject.TestProp1+'----------------');
    WriteToMemo(AMyObject.Items[i] as TMyObject);
  end;
end;

end.

